#include <IceGrid/IceGrid.h>
#include <Ice/Ice.h>
#include <CCUIC.h>
#include <string.h>

using namespace std;
using namespace CCU;

Client::~Client() {
  if(Client::_ic) {
    try {
      Client::_ic->destroy();
    }
    catch (Ice::Exception& e) {
      cerr << e << endl;
    }
  }
};

Client::Client() {

};

int
Client::run(int argc,char* argv[]) {
  //try {
	if(argc > 1) {
		cerr << appName() << ": too many arguments" << endl;
		return EXIT_FAILURE;
	}
	cout << "test" << endl;
    Client::_ic = Ice::initialize(argc, argv);
    Ice::ObjectPrx base = Client::_ic->stringToProxy(
                                "SimpleLogFile@CraneAdapter");
    Client::_stream = CranePrx::checkedCast(base);
    if (!Client::_stream) {
      cerr << "Invalid proxy" << endl;
      return EXIT_FAILURE;
    }
    return EXIT_SUCCESS;
  /*} catch (const Ice::Exception& ex) {
    cerr << ex << endl;
  } catch (const char* msg) {
    cerr << msg << endl;
  }*/
};

void
Client::setCommand(Command com) {
	LIST parameters;
	for(LIST::const_iterator it = com.getParamBegin(); it != com.getParamEnd(); ++it) {
		parameters.push_back(*it);
	}
	Client::_stream->setCommand_async(new AMI_Crane_setCommandI, com.getName(), parameters);
}

void
Client::setState(State& st) {
	// Objects
	Client::_stream->setStateObjects(st.getObjects());
	// Properties
	LIST objects = st.getObjects();
	for(LIST::const_iterator it = objects.begin(); it != objects.end(); ++it) {
		Client::_stream->setStatePropertiesPerObject((*it),st.getPropertiesOf(*it));
	}
	// Relations
	for(LIST::const_iterator it_object = objects.begin(); it_object != objects.end(); ++it_object) {
		LIST relations = st.getRelationsFrom(*it_object);
		//cout << "Objekt: " << (*it_object) << endl;
		for(LIST::const_iterator it_relation = relations.begin(); it_relation != relations.end(); ++it_relation) {
			LIST relatedObjects = st.getRelatedObjects(*it_object,*it_relation);
			//cout << " Relation: "<< (*it_relation) << endl;
			for(LIST::iterator it_relatedObject = relatedObjects.begin(); it_relatedObject != relatedObjects.end(); ++it_relatedObject) {
				//cout << "  Bezogenes Objekt: "<< (*it_relatedObject) << endl;
				Client::_stream->setStateRelation(*it_object,*it_relatedObject,*it_relation);
			}
		}
	}
	return;
}

Ice::CommunicatorPtr Client::_ic;
CranePrx Client::_stream;


